<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// FIXME error_reporting(E_ALL);


if(file_exists(INFUSIONS."aw_music_db/locale/".$settings['locale'].".php")) {
	include(INFUSIONS."aw_music_db/locale/".$settings['locale'].".php");
} else {
	include(INFUSIONS."aw_music_db/locale/German.php");
}


define("MDB_COVERS",		INFUSIONS."aw_music_db/covers/");
define("AW_IMAGE_MIME",		"image/jpeg");
define("AW_IMAGE_EMPTY",	"empty.gif");
define("MDB_SMALL_HEIGHT",	120);
define("MDB_SMALL_WIDTH",	120);


$query_id = dbquery("SELECT * FROM ".DB_PREFIX."aw_music_settings LIMIT 1");
if(!dbrows($query_id)) {
	$mdb_settings['edit_group']	= 103;
	$mdb_settings['per_page']	= 2;
	$mdb_settings['file_size']	= 100;	// in kb
	$mdb_settings['version']	= "0.3";
} else {
	$mdb_settings = dbarray($query_id);
}
define("iMDB_EDIT",	(iSUPERADMIN || checkgroup($mdb_settings['edit_group'])));


/*
 * Format..: "$key" => "$value",
 * Desc....: $key: One unique char.
 *           $value: Whatever you like.
 *
 * !!! DO NOT USE "0" AS $key !!!
 */
$g_formats = array(
	"1"	=> "CD1",
	"2"	=> "CD2",
	"M"	=> "CDMAXI",
	"V"	=> "Vinyl",
	"D"	=> "DVD",
);

/*
 * Desc....: Resulting filename: MDB_COVERS/$key_$albumid.jpg
 * Some $key names may cause problems in other parts of the infusion! If so,
 * use cryptical names like "aw_my_front" - but no too long.
 * NOTE: you may also add locale strings. Format err_$key.
 */
$g_covers = array(
	"front"	=> $locale['front'],
	"back"	=> $locale['back'],
	"inlay"	=> $locale['inlay'],
);


?>
<script type="text/javascript">
function select_artist(file, artist_id) {
	document.location.href=file+'?artist_id='+artist_id;
}

function confirm_delete(frm) {
//	return true;
	return confirm("<?php echo $locale['conf_del']; ?>");
}

function do_popup(id, img, width, height) {
	wnd = window.open("<?php echo INFUSIONS."aw_music_db/"; ?>popup.php?id="+id+"&fid="+img+"", "FIXME: caption",
		"menubar=0,scrollbars=1,status=0,toolbar=0,width=600,height=600");
	wnd.focus();
}
</script>
<?php


function aw_msg($is_ok, $err_msg="") {
	global $locale;
	echo "<div align='center' class='textbox' style='padding:10px;'>";
	if($is_ok) {
		echo $locale['ok'];
	} else {
		echo "<b>".$locale['err']."</b>";
		if(!empty($err_msg)) {
			echo "<br><br><span class='small2'>$err_msg</span>";
		}
	}
	echo "</div>\n";
	tablebreak();
}


function aw_upload_file($file, $new_id) {
	global $mdb_settings;
	if($file['size']!=0 &&
		(!is_uploaded_file($file['tmp_name'])
		|| $file['size'] > $mdb_settings['file_size']*1024
		|| $file['type'] != AW_IMAGE_MIME
		|| !copy($file['tmp_name'], MDB_COVERS.$new_id.".jpg")
		|| !chmod(MDB_COVERS.$new_id.".jpg", 0666))) {
		return false;
	}
	return true;
}


function show_artists_form($artist_id)
{
	global $locale;

	$query_id = dbquery("SELECT * FROM ".DB_PREFIX."aw_music_artists"
		." ORDER by artist_name ASC");
	if(!$query_id || dbrows($query_id)==0) {
		return NULL;
	}

	$artists = "";
	while($row = dbarray($query_id)) {
		$id = $row['artist_id'];
		if(is_null($artist_id)) {
			$artist_id = $id;
		}
		$artists .= "<option value='$id' "
			.($artist_id==$id ? ' selected' : '').">"
			.$row['artist_name']."</option>";
	}

	echo "<form method='get' action='".FUSION_SELF."'>"
		."<select class='textbox'"
			." onChange='select_artist(\"".FUSION_SELF."\","
			."this.options[this.selectedIndex].value);'>"
			."$artists</select>"
		."</form>";
	return $artist_id;
}

function show_album($album) {
	$id = $album['album_id'];
	$front_img = "<img src='".AW_IMAGE_EMPTY."'>";
	$back_img = "<img src='".AW_IMAGE_EMPTY."'>";

	if($album['album_front']!=0) {
		$front_img = "<a href='javascript:do_popup(\"$id\", \"".$album['album_front']."\");'><img src='".MDB_COVERS."s_".$album['album_front'].".jpg' alt='' border='0'></a>";
	}
	if($album['album_back']!=0) {
		$back_img = "<a href='javascript:do_popup(\"$id\", \"".$album['album_back']."\");'><img src='".MDB_COVERS."s_".$album['album_back'].".jpg' alt='' border='0'></a>";
	}
/*
	$front_img = MDB_COVERS."front_$id.jpg";
	$back_img = MDB_COVERS."back_$id.jpg";
	if(file_exists($front_img)) {
		$popup_size = getimagesize($front_img);
		$w = $popup_size[0]+40;
		$h = $popup_size[1]+80;
	} else {
		$w = 800;
		$h = 600;
	}

	if(file_exists($front_img)) {
			$front_img = "<a href='javascript:do_popup(\"$id\",\"front\",\"$w\",\"$h\");'>"
			."<img src='$front_img' height='120' width='120' border='0'>"
			."</a>";
	} else {
		$front_img = "<img src='".AW_IMAGE_EMPTY."'>";
	}

	if(file_exists($back_img)) {
		$back_img = "<a href='javascript:do_popup(\"$id\",\"back\",\"$w\",\"$h\");'>"
			."<img src='$back_img' height='120' width='120' border='0'>"
			."</a>";
	} else {
		$back_img = "<img src='".AW_IMAGE_EMPTY."'>";
	}
*/

	// get all songs
	$query_id = dbquery("SELECT song_on_medium, song_order, song_title,"
		." song_len, song_id"
		." FROM ".DB_PREFIX."aw_music_songs"
		." WHERE song_album='$id'"
		." ORDER BY song_on_medium,song_order ASC");
	unset($all_songs);
	if($query_id) {
		echo "<ul>";
		while($song = dbarray($query_id)) {
			$song['song_title'] ="<a href='show_album.php?album_id="
				.$id."&song_id=".$song['song_id']."'>"
				.stripslashes($song['song_title'])."</a>";
			$all_songs[] = $song;
		}
		echo "</ul>";
	}

	render_album_with_songs($album, $front_img, $back_img, $all_songs);
}


function show_admin_menu() {
	global $locale;

	$hrefs = array(
		$locale['cats']		=>	"cats.php",
		$locale['labels']	=>	"labels.php",
		$locale['sales']	=>	"sales.php",
		$locale['artists']	=>	"artists.php",
		$locale['albums']	=>	"albums.php",
		$locale['settings']	=>	"settings.php",
	);

	echo "<table width='100%' cellspacing='0'>\n<tr>\n";
	foreach($hrefs as $title => $file) {
		if(FUSION_SELF==$file) {
			$title = "<b>-=[ $title ]=-</b>";
		}
		echo "<td align='center'>"
			."<a href='$file'>$title</a></td>\n";
	}
	echo "</tr></table><hr>\n";
}

/* PHP-Fusion 6.00.305 */
function mdb_createthumbnail($origfile,$thumbfile,$new_w,$new_h) {
	global $settings;
	
	$origimage=imagecreatefromjpeg($origfile);
	$origwidth=imagesx($origimage);
	$origheight=imagesy($origimage);
	$size=mdb_constrainImage($origwidth,$origheight,$new_w,$new_h);
	if ($settings['thumb_compression']=="gd1") {
		$thumbimage=imagecreate($new_w,$new_h);
		$background=imagecolorallocate($thumbimage,255,255,255);
		imagefill($thumbimage,0,0,$background);
		$result=imagecopyresized($thumbimage, $origimage,round(($new_w-$size['width'])/2),round(($new_h-$size['height'])/2),0,0,$size['width'],$size['height'],$origwidth,$origheight);
	} else {
		$thumbimage=imagecreatetruecolor($new_w,$new_h);
		$background=imagecolorallocate($thumbimage,255,255,255);
		imagefill($thumbimage,0,0,$background);
		$result=imagecopyresampled($thumbimage, $origimage,round(($new_w-$size['width'])/2),round(($new_h-$size['height'])/2),0,0,$size['width'],$size['height'],$origwidth,$origheight);
	}
	touch($thumbfile);
	imageJPEG($thumbimage,$thumbfile);
	chmod($thumbfile, 0666);
}


// Photo Gallery functions by CrappoMan
function mdb_constrainImage($width, $height, $max_width, $max_height){
	if(!$height || !$width || !$max_height || !$max_width) {
		return false;
	}
	$img_width = $max_width;	// FIXME
	$img_height = $max_height;	// FIXME

	if($height>$max_height || $width>$max_width) {
		if($height>$width) {
			if ($img_width>$max_width) {
				$img_width=$max_width;
				$img_height=round(($max_width*$max_height)/$img_width);
			} else {
				$img_width=round(($width*$max_height)/$height);
				$img_height=$max_height;
			}
		} else {
			if($img_height>$max_height) {
				$img_width=round(($max_width*$max_height)/$img_height);
				$img_height=$max_height;
			} else {
				$img_width=$max_width;
				$img_height=round(($height*$max_width)/$width);
			}
		}
		return array('width'=>$img_width,'height'=>$img_height);
	}

	return array('width'=>$width, 'height'=>$height);
}

?>
